
package textfile;
import java.io.*;
public class TextFile {
    
    private char mode;
    private BufferedReader reader;
    private BufferedWriter writer;   
    
    public TextFile(String fileName, char mode) throws IOException//costruttore usato per lettura e scrittura.modalita o scrivi o leggi
    {
     this.mode='R';// mode e uguale ad R
     if((mode=='w')||(mode=='W')) // a questo if leva la R e ci mette la W o w
         this.mode='W';
      if(mode=='W')    
          writer= new BufferedWriter(new FileWriter(fileName));
      else
          reader = new BufferedReader(new FileReader(fileName));
    }
    //altro costruttore
    public TextFile(String fileName, char mode, boolean append) throws IOException//costruttore usato per lettura e scrittura.modalita o scrivi o leggi
    {
     this.mode='R';// mode e uguale ad R
     if((mode=='w')||(mode=='W')) // a questo if leva la R e ci mette la W o w
         this.mode='W';
      if(mode=='W')    
          writer= new BufferedWriter(new FileWriter(fileName,append));
      else
          reader = new BufferedReader(new FileReader(fileName));
    }
    
    public void toFile(String line) throws FileException, IOException
    {
        if(mode == 'R')
            throw new FileException("Impossibile scrivere su un file aperto in lettura");
        writer.write(line);
        writer.newLine();
        
    }
    
    public String fromFile()throws FileException, IOException
    {
        String rigaLetta;
        if(mode == 'W')
            throw new FileException("Impossibile leggere su un file aperto in scrittura");
        rigaLetta = reader.readLine();
        if(rigaLetta == null)
            throw new FileException("Fine del file!");
        return rigaLetta;
    }
    public void close()throws FileException, IOException
    {
        if(mode == 'W')
            writer.close();
        else
            reader.close();
        
    }
}
